<?php

/**
* Plugin Name: Firstdata
* Developer: Marcin Bogdański
* Author: Marcin Bogdański (Opennet)
* Author URI: http://opennet.pl/
* Version: 1.1.2
* Requires at least: 4.7
* Tested up to: 6.1.1
* Requires PHP: 5.3
* Description: Polcard Gateway
* Text Domain: firstdata
* Domain Path: /languages
*/

if(!defined('ABSPATH')) exit;
//include 'conf.php';

/**
 * Main plugin class
 */
class FirstdataPlugin {

//    const CRON_HOOK = 'do_cron';
    public static $instance;
    private $methods = array();
	
	public function __construct() {
		add_action('plugins_loaded', array($this, 'init'), 100);
//		add_action(self::CRON_HOOK, array($this, 'doCron'));
	}
	
	public static function FirstdataPlugin() {
		if (self::$instance === null) {
			self::$instance = new self();
		}
		return self::$instance;
	}
	
	public function init() {
	    if( class_exists( 'WC_Payment_Gateway' ) ) {
    		include 'classes/method.php';
	   	    include 'classes/api.php';
		    $this->init_methods();
		    add_filter('woocommerce_get_settings_pages', array($this, 'woocommerce_get_settings_pages'));	
            add_filter('woocommerce_payment_gateways', array( $this, 'woocommerce_payment_gateways'));
//            add_filter('woocommerce_available_payment_gateways', array( $this, 'woocommerce_available_payment_gateways'), 100);
            add_filter('plugin_action_links_' . plugin_basename(__FILE__), array($this, 'linksFilter'));
            load_plugin_textdomain('firstdata', false, dirname( plugin_basename( __FILE__ ) ) . '/languages');

	    }
	}

	public function init_methods() {
	    $this->methods[] = 'Firstdata_Gateway';
	}

	public function woocommerce_payment_gateways($methods) {
		foreach($this->methods as $method) {
			$methods[] = $method;
		}
		return $methods;
	}

// 	public function woocommerce_available_payment_gateways($gateways) {
// 	    if(((isset($_GET['pay_for_order']) && isset($_GET['key'])) || isset(WC()->cart))) {
// 	        if(!$gateways['firstdata']) {
// 	            $fdp_gateway = new Firstdata_Gateway();
// 	            $fdp_gateway->init();
// 	            $gateways['firstdata'] = $fdp_gateway;
// 	        }
// 	    }
// 	    else {
// 	        unset( $gateways['firstdata'] );
// 	    }
// 	    return $gateways;
// 	}

	public function woocommerce_get_settings_pages($woocommerce_settings) {
		include('classes/settings.php');
		$settings = new Firstdata_Settings();
		$woocommerce_settings[] = $settings;
		return $woocommerce_settings;
	}
	
	public function linksFilter($links) {
		$plugin_links = array(
		    '<a href="' . admin_url('admin.php?page=wc-settings&tab=firstdata_settings') . '">' . __('Settings', 'firstdata') . '</a>'
        );
        return array_merge($plugin_links, $links);
    }

//    public static function activate() {
//        $timestamp = wp_next_scheduled( self::CRON_HOOK );
//        if($timestamp === false) {
//            wp_schedule_event(time(), 'hourly', self::CRON_HOOK);
//        }
//    }
    
//    public static function deactivate() {
 //       $timestamp = wp_next_scheduled(self::CRON_HOOK);
 //       wp_unschedule_event($timestamp, self::CRON_HOOK);
//    }

//    public function doCron() {
//        error_log('doCron');
//    }

}

function FirstdataPlugin() {
    return FirstdataPlugin::FirstdataPlugin();
}

$_GLOBALS['FirstdataPlugin'] = FirstdataPlugin();

//register_activation_hook(__FILE__, array(FirstdataPlugin::class, 'activate'));
//register_deactivation_hook(__FILE__, array(FirstdataPlugin::class, 'deactivate'));
